import type { ExtractPropTypes, StyleValue } from 'vue';
import { scrollbarProps } from './props';
import './style.less';
export declare type ScrollbarProps = ExtractPropTypes<typeof scrollbarProps>;
declare const GScrollbars: import("vue").DefineComponent<{
    height: {
        type: (StringConstructor | NumberConstructor)[];
        default: string;
    };
    maxHeight: {
        type: (StringConstructor | NumberConstructor)[];
        default: string;
    };
    native: {
        type: BooleanConstructor;
        default: boolean;
    };
    wrapStyle: {
        type: import("vue").PropType<string | import("vue").CSSProperties[]>;
        default: string;
    };
    wrapClass: {
        type: (StringConstructor | ArrayConstructor)[];
        default: string;
    };
    viewClass: {
        type: (StringConstructor | ArrayConstructor)[];
        default: string;
    };
    viewStyle: {
        type: (StringConstructor | ArrayConstructor | ObjectConstructor)[];
        default: string;
    };
    noresize: BooleanConstructor;
    tag: {
        type: StringConstructor;
        default: string;
    };
    always: {
        type: BooleanConstructor;
        default: boolean;
    };
    minSize: {
        type: NumberConstructor;
        default: number;
    };
}, {
    barRef: import("vue").Ref<any>;
    wrap$: import("vue").Ref<any>;
    scrollbar$: import("vue").Ref<any>;
    resize$: import("vue").Ref<any>;
    style: import("vue").ComputedRef<StyleValue>;
    moveX: import("vue").Ref<number>;
    moveY: import("vue").Ref<number>;
    prefixCls: string;
    sizeHeight: import("vue").Ref<string>;
    sizeWidth: import("vue").Ref<string>;
    ratioX: import("vue").Ref<number>;
    ratioY: import("vue").Ref<number>;
    handleScroll: () => void;
    scrollTo: {
        (xCord: number, yCord?: number): void;
        (options: ScrollToOptions): void;
    };
    setScrollTop: (value: number) => void;
    setScrollLeft: (value: number) => void;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    scroll: ({ scrollTop, scrollLeft }: {
        scrollTop: number;
        scrollLeft: number;
    }) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{
    height: {
        type: (StringConstructor | NumberConstructor)[];
        default: string;
    };
    maxHeight: {
        type: (StringConstructor | NumberConstructor)[];
        default: string;
    };
    native: {
        type: BooleanConstructor;
        default: boolean;
    };
    wrapStyle: {
        type: import("vue").PropType<string | import("vue").CSSProperties[]>;
        default: string;
    };
    wrapClass: {
        type: (StringConstructor | ArrayConstructor)[];
        default: string;
    };
    viewClass: {
        type: (StringConstructor | ArrayConstructor)[];
        default: string;
    };
    viewStyle: {
        type: (StringConstructor | ArrayConstructor | ObjectConstructor)[];
        default: string;
    };
    noresize: BooleanConstructor;
    tag: {
        type: StringConstructor;
        default: string;
    };
    always: {
        type: BooleanConstructor;
        default: boolean;
    };
    minSize: {
        type: NumberConstructor;
        default: number;
    };
}>> & {
    onScroll?: ((args_0: {
        scrollTop: number;
        scrollLeft: number;
    }) => any) | undefined;
}, {
    height: string | number;
    always: boolean;
    maxHeight: string | number;
    native: boolean;
    wrapStyle: string | import("vue").CSSProperties[];
    wrapClass: string | unknown[];
    viewClass: string | unknown[];
    viewStyle: string | unknown[] | Record<string, any>;
    noresize: boolean;
    tag: string;
    minSize: number;
}>;
export default GScrollbars;
