import { isNumber as y, isString as j, getPrefixCls as D, isObject as K } from "@gx-design-vue/pro-utils";
import { defineComponent as X, inject as U, ref as n, computed as E, onBeforeUnmount as _, toRef as Y, createVNode as v, Transition as q, Fragment as F, watch as W, nextTick as k, provide as I, reactive as V, onMounted as J } from "vue";
import { useEventListener as B, isClient as Q, useResizeObserver as Z } from "@vueuse/core";
const ee = {
  height: {
    type: [String, Number],
    default: ""
  },
  maxHeight: {
    type: [String, Number],
    default: ""
  },
  native: {
    type: Boolean,
    default: !1
  },
  wrapStyle: {
    type: [String, Array],
    default: ""
  },
  wrapClass: {
    type: [String, Array],
    default: ""
  },
  viewClass: {
    type: [String, Array],
    default: ""
  },
  viewStyle: {
    type: [String, Array, Object],
    default: ""
  },
  noresize: Boolean,
  tag: {
    type: String,
    default: "div"
  },
  always: {
    type: Boolean,
    default: !1
  },
  minSize: {
    type: Number,
    default: 20
  }
}, te = {
  scroll: ({ scrollTop: e, scrollLeft: t }) => y(e) && y(t)
}, O = Symbol("scrollbarContextKey"), le = {
  className: String,
  always: {
    type: Boolean,
    default: !0
  },
  width: {
    type: String,
    default: ""
  },
  height: {
    type: String,
    default: ""
  },
  ratioX: {
    type: Number,
    default: 1
  },
  ratioY: {
    type: Number,
    default: 1
  }
}, se = {
  className: String,
  vertical: Boolean,
  size: String,
  move: Number,
  ratio: {
    type: Number,
    required: !0
  },
  always: Boolean
}, ae = {
  vertical: {
    offset: "offsetHeight",
    scroll: "scrollTop",
    scrollSize: "scrollHeight",
    size: "height",
    key: "vertical",
    axis: "Y",
    client: "clientY",
    direction: "top"
  },
  horizontal: {
    offset: "offsetWidth",
    scroll: "scrollLeft",
    scrollSize: "scrollWidth",
    size: "width",
    key: "horizontal",
    axis: "X",
    client: "clientX",
    direction: "left"
  }
}, oe = ({ move: e, size: t, bar: i }) => ({
  [i.size]: t,
  transform: `translate${i.axis}(${e}%)`
});
function R(e, t = "px") {
  return e ? j(e) ? e : y(e) ? `${e}${t}` : !1 : "";
}
const ie = "Thumb", M = X({
  props: se,
  setup(e) {
    const t = U(O);
    t || console.error(ie, "can not inject scrollbar context");
    const i = n(), r = n(), h = n({}), c = n(!1);
    let a = !1, d = !1, S = Q ? document.onselectstart : null;
    const s = E(() => ae[e.vertical ? "vertical" : "horizontal"]), b = E(() => oe({
      size: e.size,
      move: e.move,
      bar: s.value
    })), x = E(() => i.value[s.value.offset] ** 2 / (t == null ? void 0 : t.wrapElement)[s.value.scrollSize] / ((e == null ? void 0 : e.ratio) || 0) / r.value[s.value.offset]), $ = (o) => {
      var u;
      if (o.stopPropagation(), o.ctrlKey || [1, 2].includes(o.button))
        return;
      (u = window.getSelection()) == null || u.removeAllRanges(), C(o);
      const f = o.currentTarget;
      !f || (h.value[s.value.axis] = f[s.value.offset] - (o[s.value.client] - f.getBoundingClientRect()[s.value.direction]));
    }, z = (o) => {
      if (!r.value || !i.value || !(t != null && t.wrapElement))
        return;
      const f = Math.abs(o.target.getBoundingClientRect()[s.value.direction] - o[s.value.client]), u = r.value[s.value.offset] / 2, l = (f - u) * 100 * x.value / i.value[s.value.offset];
      t.wrapElement[s.value.scroll] = l * t.wrapElement[s.value.scrollSize] / 100;
    }, C = (o) => {
      o.stopImmediatePropagation(), a = !0, document.addEventListener("mousemove", w), document.addEventListener("mouseup", g), S = document.onselectstart, document.onselectstart = () => !1;
    }, w = (o) => {
      if (!i.value || !r.value || a === !1)
        return;
      const f = h.value[s.value.axis];
      if (!f)
        return;
      const u = (i.value.getBoundingClientRect()[s.value.direction] - o[s.value.client]) * -1, l = r.value[s.value.offset] - f, m = (u - l) * 100 * x.value / i.value[s.value.offset];
      t.wrapElement[s.value.scroll] = m * t.wrapElement[s.value.scrollSize] / 100;
    }, g = () => {
      a = !1, h.value[s.value.axis] = 0, document.removeEventListener("mousemove", w), document.removeEventListener("mouseup", g), N(), d && (c.value = !1);
    }, T = () => {
      d = !1, c.value = !!e.size;
    }, P = () => {
      d = !0, c.value = a;
    };
    _(() => {
      N(), document.removeEventListener("mouseup", g);
    });
    const N = () => {
      document.onselectstart !== S && (document.onselectstart = S);
    };
    return B(Y(t, "scrollbarElement"), "mousemove", T), B(Y(t, "scrollbarElement"), "mouseleave", P), () => v(q, {
      name: `${e.className}-fade`
    }, {
      default: () => [v("div", {
        ref: (o) => i.value = o,
        class: e.always || c.value ? [`${e.className}-bar`, "is-" + s.value.key] : [`${e.className}-bar`, "is-" + s.value.key, "hidden"],
        onMousedown: z
      }, [v("div", {
        ref: (o) => r.value = o,
        class: `${e.className}-thumb`,
        style: b.value,
        onMousedown: $
      }, null)])]
    });
  }
});
M.inheritAttrs = !1;
const G = X({
  props: le,
  setup(e) {
    const t = n(0), i = n(0), r = 4;
    return {
      moveX: t,
      moveY: i,
      handleScroll: (c) => {
        if (c) {
          const a = c.offsetHeight - r, d = c.offsetWidth - r;
          i.value = c.scrollTop * 100 / a * e.ratioY, t.value = c.scrollLeft * 100 / d * e.ratioX;
        }
      }
    };
  },
  render() {
    return v(F, null, [v(M, {
      className: this.className,
      move: this.moveX,
      ratio: this.ratioX,
      size: this.width,
      always: this.always
    }, null), v(M, {
      className: this.className,
      move: this.moveY,
      ratio: this.ratioY,
      size: this.height,
      vertical: !0,
      always: this.always
    }, null)]);
  }
});
G.inheritAttrs = !1;
const ne = X({
  name: "GScrollbars",
  props: ee,
  emits: te,
  setup(e, {
    emit: t
  }) {
    const i = D({
      suffixCls: "scrollbar"
    });
    let r, h;
    const c = n(), a = n(), d = n(), S = n("0"), s = n("0"), b = n(), x = n(0), $ = n(0), z = n(1), C = n(1), w = "GScrollbars", g = 4, T = E(() => {
      const l = {};
      return e.height && (l.height = R(e.height)), e.maxHeight && (l.maxHeight = R(e.maxHeight)), [e.wrapStyle, l];
    }), P = () => {
      var l;
      a.value && ((l = b.value) == null || l.handleScroll(a.value), t("scroll", {
        scrollTop: a.value.scrollTop,
        scrollLeft: a.value.scrollLeft
      }));
    };
    function N(l, m) {
      K(l) ? a.value.scrollTo(l) : y(l) && y(m) && a.value.scrollTo(l, m);
    }
    const o = (l) => {
      if (!y(l)) {
        console.warn(w, "value \u5FC5\u987B\u4E3A\u6570\u5B57");
        return;
      }
      a.value.scrollTop = l;
    }, f = (l) => {
      if (!y(l)) {
        console.warn(w, "value \u5FC5\u987B\u4E3A\u6570\u5B57");
        return;
      }
      a.value.scrollLeft = l;
    }, u = () => {
      if (!a.value)
        return;
      const l = a.value.offsetHeight - g, m = a.value.offsetWidth - g, A = l ** 2 / a.value.scrollHeight, L = m ** 2 / a.value.scrollWidth, H = Math.max(A, e.minSize), p = Math.max(L, e.minSize);
      z.value = A / (l - A) / (H / (l - H)), C.value = L / (m - L) / (p / (m - p)), s.value = H + g < l ? `${H}px` : "", S.value = p + g < m ? `${p}px` : "";
    };
    return W(() => e.noresize, (l) => {
      l ? (r == null || r(), h == null || h()) : ({
        stop: r
      } = Z(d, u), h = B("resize", u));
    }, {
      immediate: !0
    }), W(() => [e.maxHeight, e.height], () => {
      e.native || k(() => {
        var l;
        u(), a.value && ((l = b.value) == null || l.handleScroll(a.value));
      });
    }), I(O, V({
      scrollbarElement: c,
      wrapElement: a
    })), J(() => {
      e.native || k(() => u());
    }), {
      barRef: b,
      wrap$: a,
      scrollbar$: c,
      resize$: d,
      style: T,
      moveX: x,
      moveY: $,
      prefixCls: i,
      sizeHeight: s,
      sizeWidth: S,
      ratioX: C,
      ratioY: z,
      handleScroll: P,
      scrollTo: N,
      setScrollTop: o,
      setScrollLeft: f
    };
  },
  render() {
    const e = this.tag;
    return v("div", {
      ref: (t) => this.scrollbar$ = t,
      class: this.prefixCls
    }, [v("div", {
      ref: (t) => this.wrap$ = t,
      class: [this.wrapClass, `${this.prefixCls}-wrap`, this.native ? "" : `${this.prefixCls}-wrap-hidden-default`],
      style: this.style,
      onScroll: this.handleScroll
    }, [v(e, {
      ref: (t) => this.resize$ = t,
      class: [`${this.prefixCls}-view`, this.viewClass],
      style: this.viewStyle
    }, {
      default: () => {
        var t, i;
        return [(i = (t = this.$slots).default) == null ? void 0 : i.call(t)];
      }
    })]), !this.native && v(G, {
      ref: (t) => this.barRef = t,
      className: this.prefixCls,
      height: this.sizeHeight,
      width: this.sizeWidth,
      always: this.always,
      ratioX: this.ratioX,
      ratioY: this.ratioY
    }, null)]);
  }
});
ne.inheritAttrs = !1;
export {
  ne as GScrollbars,
  ne as default,
  ee as scrollbarProps
};
